<?php
////////////////////////////////////////////////////////////////////////////////////////////////////
//
//		File:
//			meta.php
//		Description:
//			This file compiles video specific meta fields for posts.
//		Copyright:
//			Copyright (c) 2014 Ternstyle LLC.
//		License:
//			This software is licensed under the terms of the End User License Agreement (EULA) 
//			provided with this software. In the event the EULA is not present with this software
//			or you have not read it, please visit:
//			http://www.ternstyle.us/automatic-video-posts-plugin-for-wordpress/license.html
//
////////////////////////////////////////////////////////////////////////////////////////////////////

/****************************************Commence Script*******************************************/

//                                *******************************                                 //
//________________________________** INITIALIZE                **_________________________________//
//////////////////////////////////**                           **///////////////////////////////////
//                                **                           **                                 //
//                                *******************************                                 //
$pages = array('post.php','edit.php','post-new.php','page.php','page-new.php');
if(!in_array($GLOBALS['pagenow'],$pages)) {
	return;
}
//                                *******************************                                 //
//________________________________** ADD EVENTS                **_________________________________//
//////////////////////////////////**                           **///////////////////////////////////
//                                **                           **                                 //
//                                *******************************                                 //
add_action('admin_menu','WP_ayvpp_box');
add_action('save_post','WP_ayvpp_save_post');
add_action('publish_post','WP_ayvpp_save_post');
//                                *******************************                                 //
//________________________________** ACTIONS                   **_________________________________//
//////////////////////////////////**                           **///////////////////////////////////
//                                **                           **                                 //
//                                *******************************                                 //
function WP_ayvpp_save_post($i) {

	if(!isset($_POST['WP_ayvpp_nonce']) or !wp_verify_nonce($_POST['WP_ayvpp_nonce'],AYVPP_DIR.'/core/meta.php') or !$i or !current_user_can('edit_post',$i)) {
		return;
	}
	
	update_post_meta($i,'_ayvpp_video',$_POST['_ayvpp_video']);
	update_post_meta($i,'_ayvpp_video_url',$_POST['_ayvpp_video_url']);
	update_post_meta($i,'_ayvpp_author',$_POST['_ayvpp_author']);
	update_post_meta($i,'_ayvpp_auto_play',(int)$_POST['_ayvpp_auto_play']);
	update_post_meta($i,'_ayvpp_show_related',(int)$_POST['_ayvpp_show_related']);
}
//                                *******************************                                 //
//________________________________** META BOXES                **_________________________________//
//////////////////////////////////**                           **///////////////////////////////////
//                                **                           **                                 //
//                                *******************************                                 //
function WP_ayvpp_box() {
	global $post;
	
	//if(!isset($_GET['post'])) {
	//	return;
	//}
	
	//$post = get_post($_GET['post']);
	//$video = new youtube_video();
	//if(isset($video->meta['_ayvpp_video']) and !empty($video->meta['_ayvpp_video'])) {
		add_meta_box('ayvpp_meta_box','Automatic Video Posts','WP_ayvpp_meta','post','normal');
	//}
}
function WP_ayvpp_meta() {
	global $post;
	
	$meta = get_post_meta($post->ID);
	include(AYVPP_DIR.'/views/meta.php');
	
}

/****************************************Terminate Script******************************************/
?>